//CopierReperes_205f.js
// 12.02.09 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//Ce script sert  copier des repres slectionns  la page slectionn

// activer l'affichage de dialogues (mesure prventive)
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

// tester la slection
selItems = app.selection;
nItems = selItems.length;
if (nItems == 0) {
	alert ("Il n'y a pas de slection.", "Attention");
	exit();
}

var curDoc = app.documents[0];

// mettre le point zro  zro/zro
var zP = curDoc.zeroPoint; 
if (zP != [0,0]) { 
	curDoc.zeroPoint = [0,0]; 
} 

// mettre l'origine des rgles  "Page"
var rO = curDoc.viewPreferences.rulerOrigin;
if (rO != 1380143215) {
	curDoc.viewPreferences.rulerOrigin = RulerOrigin.pageOrigin;
}

// extraire les valeurs mmorises
var guideStr = "";
try {
	guideStr = curDoc.extractLabel("guideProps");
}
catch (e) {
}

// mmoriser des attributs
var allLayers = curDoc.layers;
var allLNames = allLayers.everyItem().name;
var nLayers = allLayers.length;
var layerLocks = new Array ();
if (nLayers > 1) {
	var curLayer = app.activeWindow.activeLayer.index;
	dlogLayers = ["Le(s) mme(s)"].concat(allLNames);
}

// mmoriser le verrouillage des calques et l'annuler (si ncessaire)
var layerLocks = new Array ();
for (var i=0; i<nLayers; i++) {
	if (allLayers[i].locked == true) {
		allLayers[i].locked = false;
		layerLocks.push(true);
	}
	else {
		layerLocks.push(false);
	}
}

var curSpr = app.activeWindow.activeSpread;
var docOff = (curSpr.pages[0].documentOffset)+1;
var nPages = curSpr.pages.length;
var pW = curDoc.documentPreferences.pageWidth;

var curPage = app.activeWindow.activePage;
var curName = curPage.name;
var curParent = curPage.parent;

var isMaster = false;
if (curParent == "[object MasterSpread]") {
	isMaster = true;
}

var masNameList = new Array ();
var masPageList = new Array ();
masSpreads = curDoc.masterSpreads;
var nSpreads = masSpreads.length;
for (var s=0; s<nSpreads; s++) {
	masNameList.push(masSpreads[s].pages[0].name);
	nPag = masSpreads[s].pages.length;
	for (var p=0; p<nPag; p++) {
		curPage = masSpreads[s].pages[p].name + "" + (p+1);
		masPageList.push(curPage);
	}
}

// prparer le dialogue
var docList = curDoc.pages.everyItem().name;
var pageList = masPageList.concat(docList);
var propPage = -1;
var targetPage;
if (isMaster) {
	if (nPages > 1) {
		targetPage = (curSpr.pages.item(-1).name) + 2;
	}
	else {
		try {
			targetPage = curDoc.pages[docOff].name;
		}
		catch (e) {
			var targetPage = curDoc.pages[0].name;
		}
	}
	for (var i=0; i<masPageList.length; i++) {
		if (masPageList[i] == targetPage) {
			propPage = i;
			break;
		}
		if (propPage == -1) {
			propPage = 0;
		}
	}
}
else {
	if (nPages > 1) {
		var targetPage = curSpr.pages.item(-1).name;
	}
	else {
		try {
			var targetPage = curDoc.pages[docOff].name;
		}
		catch (e) {
			var targetPage = curDoc.pages[0].name;
		}
	}
	for (var i=0; i<pageList.length; i++) {
		if (pageList[i] == targetPage) {
			propPage = i;
			break;
		}
		if (propPage == -1) {
			propPage = 0;
		}
	}
}

var propLayer, rMir, rNor;
if (guideStr != "") {
	var guideList = guideStr.split("#");
	try {
		tmpLayer = guideList[0]*1;
		propLayer = tmpLayer;
	}
	catch (e) {
		propLayer = 0;
	}
	if (guideList[1] == "true") {
		rMir = 1;
		rNor = 0;
	}
	else {
		rMir = 0;
		rNor = 1;
	}
}
else {
	propLayer = 0;
	rMir = 1;
	rNor = 0;
}

// effacer des dialogues qui sont ventuellement rests dans la mmoire
try {
	app.dialogs.everyItem().destroy();
}
catch (e) {
}

var aDialog = app.dialogs.add({name:"Copier des repres"});
with (aDialog) {
	with (dialogColumns.add()) {
		if (nLayers == 1) {
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Page cible:"});
						staticTexts.add({staticLabel:" "});
					}
					var pageNames = dropdowns.add({stringList:pageList, selectedIndex:propPage});
				}
			}
		}
		else {
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Page cible:"});
						staticTexts.add({staticLabel:" "});
					}
					var pageNames = dropdowns.add({stringList:pageList, selectedIndex:propPage, minWidth:150});
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Calque(s) cible(s):"});
						staticTexts.add({staticLabel:" "});
					}
					var layerNames = dropdowns.add({stringList:dlogLayers, selectedIndex:propLayer, minWidth:150});
				}
			}
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:" ", minWidth:8});
			var mirButtons = radiobuttonGroups.add();
			with (mirButtons) {
				radiobuttonControls.add({staticLabel:"miroiter", checkedState:rMir});
				radiobuttonControls.add({staticLabel:"normal", checkedState:rNor});
			}
		}
	}
	with (dialogColumns.add()) {
		staticTexts.add({staticLabel:" ", minWidth:4});
	}
}
// montrer le dialogue et extraire les valeurs
var dResult = aDialog.show();
var targetMaster = false;
if (dResult == true) {
	var selPage = pageNames.selectedIndex;
	if (selPage <= masPageList.length) {
		masNamePg = pageList[selPage];
		targetMaster = true;
	}
	else {
		selPage = selPage - masPageList.length;
	}
	var targetLayer;
	if (nLayers > 1) {
		storeLayer = (layerNames.selectedIndex);
		targetLayer = storeLayer-1;
	}
	else {
		storeLayer = 0;
	}
	var mirLabel = mirButtons.selectedButton;
	var mirBtn = mirLabel;
	if (mirBtn == 0) {
		mirror = true;
	}
	else if (mirBtn == 1) {
		mirror = false;
	}
}
else {
	aDialog.destroy();
	resetAsBefore()
	exit();
}
aDialog.destroy();

// mmoriser le rsultat
guideStr = storeLayer + "#" + mirror;
curDoc.insertLabel("guideProps", guideStr); 

// wenn Master als Ziel, den Namen und die Ziffer speichern
// mmoriser le nom du calque et la page si la cible est "Gabarit"
if (targetMaster) {
	var masName = masNamePg.slice(0,-1);
	var masPage = (masNamePg.slice(-1)*1)-1;
	var masInd = 0;
	var nMas = masNameList.length;
	for (var m=0; m<nMas; m++) {
		if (masName == masNameList[m]) {
			masInd = m;
			break;
		}
	}
}

// dclarer des variables
var curCol;
var curItem;
var curPos;
var curProps;
var curThr;
var ftPage;
var lock;
var newGuide;
var okay;
var orient;
var tgtLock = false;
if (nLayers > 1) {
	app.activeWindow.activeLayer = curDoc.layers[targetLayer];
	if (curDoc.layers[targetLayer].locked == true) {
		tgtLock = true;
		curDoc.layers[targetLayer].locked = false;
	}
}
var sameSpread = false;
try {
	if (curSpr == curDoc.pages[selPage].parent) {
		sameSpread = true;
	}
	else {
		sameSpread = false;
	}
}
catch (e) {
}
// une boucle  travers la slection
for (var i=0; i<nItems; i++) {
	okay = true;
	curItem = selItems[i];
	// tester le type de l'objet actuel
	if (curItem.constructor.name == "Guide") {
		// mmoriser des attributs
		curProps = curItem.properties;
		curCol = curProps.guideColor;
		curLay = curProps.itemLayer;
		curPos = curProps.location;
		curThr = curProps.viewThreshold;
		ftPage = curProps.fitToPage;
		lock = curProps.locked;
		orient = curProps.orientation;
		// un repre planche horizontal ne doit pas tre copi...
		if (orient == 1752134266 && ftPage == false) {
			// ... si la page cible se trouve sur la mme planche (le flag 'okay' est mis  'false')
			if (sameSpread) {
				okay = false;
			}
		}
		if (okay) {
			lock = curProps.locked;
			if (targetMaster) {
				try {
					// quand il s'agit d'un repre horizontal
					if (orient == 1752134266) {
						// crer le repre
						if (targetLayer == -1) {
							newGuide = curDoc.masterSpreads[masInd].pages.item(masPage).guides.add(undefined, {itemLayer:curLay, orientation:HorizontalOrVertical.horizontal, location:curPos});
						}
						else {
							newGuide = curDoc.masterSpreads[masInd].pages.item(masPage).guides.add(undefined, {orientation:HorizontalOrVertical.horizontal, location:curPos});
						}
					}
					// sinon vertical
					else {
						if (mirror) { //si demand, calculer la valeur miroit
							curPos = pW-curPos;
						}
						// crer le repre
						if (targetLayer == -1) {
							newGuide = curDoc.masterSpreads[masInd].pages.item(masPage).guides.add(undefined, {itemLayer:curLay, orientation:HorizontalOrVertical.vertical, location:curPos});
						}
						else {
							newGuide = curDoc.masterSpreads[masInd].pages.item(masPage).guides.add(undefined, {orientation:HorizontalOrVertical.vertical, location:curPos});
						}
					}
					// appliquer d'autres attributs: planche ou page, la couleur, le seuil, le verrouillage
					newGuide.properties = {fitToPage:ftPage, guideColor:curCol, viewThreshold:curThr, locked:lock};
				}
				catch (e) {
				}
			}
			else {
				try {
					// quand il s'agit d'un repre horizontal
					if (orient == 1752134266) {
						// crer le repre
						if (targetLayer == -1) {
							newGuide = curDoc.pages[selPage].guides.add(undefined, {itemLayer:curLay, orientation:HorizontalOrVertical.horizontal, location:curPos});
						}
						else {
							newGuide = curDoc.pages[selPage].guides.add(undefined, {orientation:HorizontalOrVertical.horizontal, location:curPos});
						}
					}
					// sinon vertical
					else {
						if (mirror) { //si demand, calculer la valeur miroit
							curPos = pW-curPos;
						}
						// crer le repre
						if (targetLayer == -1) {
							newGuide = curDoc.pages[selPage].guides.add(undefined, {itemLayer:curLay, orientation:HorizontalOrVertical.vertical, location:curPos});
						}
						else {
							newGuide = curDoc.pages[selPage].guides.add(undefined, {orientation:HorizontalOrVertical.vertical, location:curPos});
						}
					}
					// appliquer d'autres attributs: planche ou page, la couleur, le seuil, le verrouillage
					newGuide.properties = {fitToPage:ftPage, guideColor:curCol, viewThreshold:curThr, locked:lock};
				}
				catch (e) {
				}
			}
		}
	}
}

resetAsBefore();

// rtablir les modifications
function resetAsBefore() {
	// rtablir l'origine des rgles
	if (rO != 1380143215) {
		try {
			curDoc.viewPreferences.rulerOrigin = rO;
		}
		catch (e) {
		}
	}
	
	// rtablir le point zro (si ncessaire) 
	if (zP != [0,0]) { 
		curDoc.zeroPoint = zP; 
	} 
	
	// rtablir le verrouillage des calques (si ncessaire)
	for (var i=0; i<(nLayers); i++) {
		allLayers[i].locked = layerLocks[i];
	}
	
	// quand il y a plus d'un calque
	if (nLayers > 1) {
		// slectionner le calque initial
		app.activeWindow.activeLayer = curDoc.layers[curLayer];
	}
}